<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFleetInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfFleetInfo extends AbstractStructArrayBase
{
    /**
     * The FleetInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\FleetInfo[]
     */
    public $FleetInfo;
    /**
     * Constructor method for ArrayOfFleetInfo
     * @uses ArrayOfFleetInfo::setFleetInfo()
     * @param \StructType\FleetInfo[] $fleetInfo
     */
    public function __construct(array $fleetInfo = array())
    {
        $this
            ->setFleetInfo($fleetInfo);
    }
    /**
     * Get FleetInfo value
     * @return \StructType\FleetInfo[]|null
     */
    public function getFleetInfo()
    {
        return $this->FleetInfo;
    }
    /**
     * Set FleetInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\FleetInfo[] $fleetInfo
     * @return \ArrayType\ArrayOfFleetInfo
     */
    public function setFleetInfo(array $fleetInfo = array())
    {
        foreach ($fleetInfo as $arrayOfFleetInfoFleetInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfFleetInfoFleetInfoItem instanceof \StructType\FleetInfo) {
                throw new \InvalidArgumentException(sprintf('The FleetInfo property can only contain items of \StructType\FleetInfo, "%s" given', is_object($arrayOfFleetInfoFleetInfoItem) ? get_class($arrayOfFleetInfoFleetInfoItem) : gettype($arrayOfFleetInfoFleetInfoItem)), __LINE__);
            }
        }
        $this->FleetInfo = $fleetInfo;
        return $this;
    }
    /**
     * Add item to FleetInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\FleetInfo $item
     * @return \ArrayType\ArrayOfFleetInfo
     */
    public function addToFleetInfo(\StructType\FleetInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FleetInfo) {
            throw new \InvalidArgumentException(sprintf('The FleetInfo property can only contain items of \StructType\FleetInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FleetInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FleetInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FleetInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FleetInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FleetInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FleetInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FleetInfo
     */
    public function getAttributeName()
    {
        return 'FleetInfo';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfFleetInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
