<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfItPointLog ArrayType
 * @subpackage Arrays
 */
class ArrayOfItPointLog extends AbstractStructArrayBase
{
    /**
     * The ItPointLog
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ItPointLog[]
     */
    public $ItPointLog;
    /**
     * Constructor method for ArrayOfItPointLog
     * @uses ArrayOfItPointLog::setItPointLog()
     * @param \StructType\ItPointLog[] $itPointLog
     */
    public function __construct(array $itPointLog = array())
    {
        $this
            ->setItPointLog($itPointLog);
    }
    /**
     * Get ItPointLog value
     * @return \StructType\ItPointLog[]|null
     */
    public function getItPointLog()
    {
        return $this->ItPointLog;
    }
    /**
     * Set ItPointLog value
     * @throws \InvalidArgumentException
     * @param \StructType\ItPointLog[] $itPointLog
     * @return \ArrayType\ArrayOfItPointLog
     */
    public function setItPointLog(array $itPointLog = array())
    {
        foreach ($itPointLog as $arrayOfItPointLogItPointLogItem) {
            // validation for constraint: itemType
            if (!$arrayOfItPointLogItPointLogItem instanceof \StructType\ItPointLog) {
                throw new \InvalidArgumentException(sprintf('The ItPointLog property can only contain items of \StructType\ItPointLog, "%s" given', is_object($arrayOfItPointLogItPointLogItem) ? get_class($arrayOfItPointLogItPointLogItem) : gettype($arrayOfItPointLogItPointLogItem)), __LINE__);
            }
        }
        $this->ItPointLog = $itPointLog;
        return $this;
    }
    /**
     * Add item to ItPointLog value
     * @throws \InvalidArgumentException
     * @param \StructType\ItPointLog $item
     * @return \ArrayType\ArrayOfItPointLog
     */
    public function addToItPointLog(\StructType\ItPointLog $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ItPointLog) {
            throw new \InvalidArgumentException(sprintf('The ItPointLog property can only contain items of \StructType\ItPointLog, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ItPointLog[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ItPointLog|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ItPointLog|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ItPointLog|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ItPointLog|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ItPointLog|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ItPointLog
     */
    public function getAttributeName()
    {
        return 'ItPointLog';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfItPointLog
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
