<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMobileCommand ArrayType
 * @subpackage Arrays
 */
class ArrayOfMobileCommand extends AbstractStructArrayBase
{
    /**
     * The MobileCommand
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\MobileCommand[]
     */
    public $MobileCommand;
    /**
     * Constructor method for ArrayOfMobileCommand
     * @uses ArrayOfMobileCommand::setMobileCommand()
     * @param \StructType\MobileCommand[] $mobileCommand
     */
    public function __construct(array $mobileCommand = array())
    {
        $this
            ->setMobileCommand($mobileCommand);
    }
    /**
     * Get MobileCommand value
     * @return \StructType\MobileCommand[]|null
     */
    public function getMobileCommand()
    {
        return $this->MobileCommand;
    }
    /**
     * Set MobileCommand value
     * @throws \InvalidArgumentException
     * @param \StructType\MobileCommand[] $mobileCommand
     * @return \ArrayType\ArrayOfMobileCommand
     */
    public function setMobileCommand(array $mobileCommand = array())
    {
        foreach ($mobileCommand as $arrayOfMobileCommandMobileCommandItem) {
            // validation for constraint: itemType
            if (!$arrayOfMobileCommandMobileCommandItem instanceof \StructType\MobileCommand) {
                throw new \InvalidArgumentException(sprintf('The MobileCommand property can only contain items of \StructType\MobileCommand, "%s" given', is_object($arrayOfMobileCommandMobileCommandItem) ? get_class($arrayOfMobileCommandMobileCommandItem) : gettype($arrayOfMobileCommandMobileCommandItem)), __LINE__);
            }
        }
        $this->MobileCommand = $mobileCommand;
        return $this;
    }
    /**
     * Add item to MobileCommand value
     * @throws \InvalidArgumentException
     * @param \StructType\MobileCommand $item
     * @return \ArrayType\ArrayOfMobileCommand
     */
    public function addToMobileCommand(\StructType\MobileCommand $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MobileCommand) {
            throw new \InvalidArgumentException(sprintf('The MobileCommand property can only contain items of \StructType\MobileCommand, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MobileCommand[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MobileCommand|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MobileCommand|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MobileCommand|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MobileCommand|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MobileCommand|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MobileCommand
     */
    public function getAttributeName()
    {
        return 'MobileCommand';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfMobileCommand
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
