<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMobileStatusLog ArrayType
 * @subpackage Arrays
 */
class ArrayOfMobileStatusLog extends AbstractStructArrayBase
{
    /**
     * The MobileStatusLog
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\MobileStatusLog[]
     */
    public $MobileStatusLog;
    /**
     * Constructor method for ArrayOfMobileStatusLog
     * @uses ArrayOfMobileStatusLog::setMobileStatusLog()
     * @param \StructType\MobileStatusLog[] $mobileStatusLog
     */
    public function __construct(array $mobileStatusLog = array())
    {
        $this
            ->setMobileStatusLog($mobileStatusLog);
    }
    /**
     * Get MobileStatusLog value
     * @return \StructType\MobileStatusLog[]|null
     */
    public function getMobileStatusLog()
    {
        return $this->MobileStatusLog;
    }
    /**
     * Set MobileStatusLog value
     * @throws \InvalidArgumentException
     * @param \StructType\MobileStatusLog[] $mobileStatusLog
     * @return \ArrayType\ArrayOfMobileStatusLog
     */
    public function setMobileStatusLog(array $mobileStatusLog = array())
    {
        foreach ($mobileStatusLog as $arrayOfMobileStatusLogMobileStatusLogItem) {
            // validation for constraint: itemType
            if (!$arrayOfMobileStatusLogMobileStatusLogItem instanceof \StructType\MobileStatusLog) {
                throw new \InvalidArgumentException(sprintf('The MobileStatusLog property can only contain items of \StructType\MobileStatusLog, "%s" given', is_object($arrayOfMobileStatusLogMobileStatusLogItem) ? get_class($arrayOfMobileStatusLogMobileStatusLogItem) : gettype($arrayOfMobileStatusLogMobileStatusLogItem)), __LINE__);
            }
        }
        $this->MobileStatusLog = $mobileStatusLog;
        return $this;
    }
    /**
     * Add item to MobileStatusLog value
     * @throws \InvalidArgumentException
     * @param \StructType\MobileStatusLog $item
     * @return \ArrayType\ArrayOfMobileStatusLog
     */
    public function addToMobileStatusLog(\StructType\MobileStatusLog $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MobileStatusLog) {
            throw new \InvalidArgumentException(sprintf('The MobileStatusLog property can only contain items of \StructType\MobileStatusLog, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MobileStatusLog[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MobileStatusLog|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MobileStatusLog|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MobileStatusLog|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MobileStatusLog|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MobileStatusLog|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MobileStatusLog
     */
    public function getAttributeName()
    {
        return 'MobileStatusLog';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfMobileStatusLog
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
