<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPassengersLog ArrayType
 * @subpackage Arrays
 */
class ArrayOfPassengersLog extends AbstractStructArrayBase
{
    /**
     * The PassengersLog
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PassengersLog[]
     */
    public $PassengersLog;
    /**
     * Constructor method for ArrayOfPassengersLog
     * @uses ArrayOfPassengersLog::setPassengersLog()
     * @param \StructType\PassengersLog[] $passengersLog
     */
    public function __construct(array $passengersLog = array())
    {
        $this
            ->setPassengersLog($passengersLog);
    }
    /**
     * Get PassengersLog value
     * @return \StructType\PassengersLog[]|null
     */
    public function getPassengersLog()
    {
        return $this->PassengersLog;
    }
    /**
     * Set PassengersLog value
     * @throws \InvalidArgumentException
     * @param \StructType\PassengersLog[] $passengersLog
     * @return \ArrayType\ArrayOfPassengersLog
     */
    public function setPassengersLog(array $passengersLog = array())
    {
        foreach ($passengersLog as $arrayOfPassengersLogPassengersLogItem) {
            // validation for constraint: itemType
            if (!$arrayOfPassengersLogPassengersLogItem instanceof \StructType\PassengersLog) {
                throw new \InvalidArgumentException(sprintf('The PassengersLog property can only contain items of \StructType\PassengersLog, "%s" given', is_object($arrayOfPassengersLogPassengersLogItem) ? get_class($arrayOfPassengersLogPassengersLogItem) : gettype($arrayOfPassengersLogPassengersLogItem)), __LINE__);
            }
        }
        $this->PassengersLog = $passengersLog;
        return $this;
    }
    /**
     * Add item to PassengersLog value
     * @throws \InvalidArgumentException
     * @param \StructType\PassengersLog $item
     * @return \ArrayType\ArrayOfPassengersLog
     */
    public function addToPassengersLog(\StructType\PassengersLog $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PassengersLog) {
            throw new \InvalidArgumentException(sprintf('The PassengersLog property can only contain items of \StructType\PassengersLog, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PassengersLog[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PassengersLog|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PassengersLog|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PassengersLog|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PassengersLog|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PassengersLog|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PassengersLog
     */
    public function getAttributeName()
    {
        return 'PassengersLog';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPassengersLog
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
