<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfServiceStatusLog ArrayType
 * @subpackage Arrays
 */
class ArrayOfServiceStatusLog extends AbstractStructArrayBase
{
    /**
     * The ServiceStatusLog
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ServiceStatusLog[]
     */
    public $ServiceStatusLog;
    /**
     * Constructor method for ArrayOfServiceStatusLog
     * @uses ArrayOfServiceStatusLog::setServiceStatusLog()
     * @param \StructType\ServiceStatusLog[] $serviceStatusLog
     */
    public function __construct(array $serviceStatusLog = array())
    {
        $this
            ->setServiceStatusLog($serviceStatusLog);
    }
    /**
     * Get ServiceStatusLog value
     * @return \StructType\ServiceStatusLog[]|null
     */
    public function getServiceStatusLog()
    {
        return $this->ServiceStatusLog;
    }
    /**
     * Set ServiceStatusLog value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceStatusLog[] $serviceStatusLog
     * @return \ArrayType\ArrayOfServiceStatusLog
     */
    public function setServiceStatusLog(array $serviceStatusLog = array())
    {
        foreach ($serviceStatusLog as $arrayOfServiceStatusLogServiceStatusLogItem) {
            // validation for constraint: itemType
            if (!$arrayOfServiceStatusLogServiceStatusLogItem instanceof \StructType\ServiceStatusLog) {
                throw new \InvalidArgumentException(sprintf('The ServiceStatusLog property can only contain items of \StructType\ServiceStatusLog, "%s" given', is_object($arrayOfServiceStatusLogServiceStatusLogItem) ? get_class($arrayOfServiceStatusLogServiceStatusLogItem) : gettype($arrayOfServiceStatusLogServiceStatusLogItem)), __LINE__);
            }
        }
        $this->ServiceStatusLog = $serviceStatusLog;
        return $this;
    }
    /**
     * Add item to ServiceStatusLog value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceStatusLog $item
     * @return \ArrayType\ArrayOfServiceStatusLog
     */
    public function addToServiceStatusLog(\StructType\ServiceStatusLog $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ServiceStatusLog) {
            throw new \InvalidArgumentException(sprintf('The ServiceStatusLog property can only contain items of \StructType\ServiceStatusLog, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ServiceStatusLog[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ServiceStatusLog|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ServiceStatusLog|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ServiceStatusLog|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ServiceStatusLog|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ServiceStatusLog|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ServiceStatusLog
     */
    public function getAttributeName()
    {
        return 'ServiceStatusLog';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfServiceStatusLog
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
