<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfServicesLog ArrayType
 * @subpackage Arrays
 */
class ArrayOfServicesLog extends AbstractStructArrayBase
{
    /**
     * The ServicesLog
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ServicesLog[]
     */
    public $ServicesLog;
    /**
     * Constructor method for ArrayOfServicesLog
     * @uses ArrayOfServicesLog::setServicesLog()
     * @param \StructType\ServicesLog[] $servicesLog
     */
    public function __construct(array $servicesLog = array())
    {
        $this
            ->setServicesLog($servicesLog);
    }
    /**
     * Get ServicesLog value
     * @return \StructType\ServicesLog[]|null
     */
    public function getServicesLog()
    {
        return $this->ServicesLog;
    }
    /**
     * Set ServicesLog value
     * @throws \InvalidArgumentException
     * @param \StructType\ServicesLog[] $servicesLog
     * @return \ArrayType\ArrayOfServicesLog
     */
    public function setServicesLog(array $servicesLog = array())
    {
        foreach ($servicesLog as $arrayOfServicesLogServicesLogItem) {
            // validation for constraint: itemType
            if (!$arrayOfServicesLogServicesLogItem instanceof \StructType\ServicesLog) {
                throw new \InvalidArgumentException(sprintf('The ServicesLog property can only contain items of \StructType\ServicesLog, "%s" given', is_object($arrayOfServicesLogServicesLogItem) ? get_class($arrayOfServicesLogServicesLogItem) : gettype($arrayOfServicesLogServicesLogItem)), __LINE__);
            }
        }
        $this->ServicesLog = $servicesLog;
        return $this;
    }
    /**
     * Add item to ServicesLog value
     * @throws \InvalidArgumentException
     * @param \StructType\ServicesLog $item
     * @return \ArrayType\ArrayOfServicesLog
     */
    public function addToServicesLog(\StructType\ServicesLog $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ServicesLog) {
            throw new \InvalidArgumentException(sprintf('The ServicesLog property can only contain items of \StructType\ServicesLog, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ServicesLog[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ServicesLog|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ServicesLog|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ServicesLog|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ServicesLog|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ServicesLog|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ServicesLog
     */
    public function getAttributeName()
    {
        return 'ServicesLog';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfServicesLog
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
