<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Alert StructType
 * @subpackage Structs
 */
class Alert extends AbstractStructBase
{
    /**
     * The regId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $regId;
    /**
     * The mId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $mId;
    /**
     * The mDescription
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $mDescription;
    /**
     * The aType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $aType;
    /**
     * The aDescription
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $aDescription;
    /**
     * The aAlert_GMT
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $aAlert_GMT;
    /**
     * The aDeleted
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $aDeleted;
    /**
     * The aDeleted_GMT
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $aDeleted_GMT;
    /**
     * The aUserDeleted
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $aUserDeleted;
    /**
     * The aComments
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $aComments;
    /**
     * Constructor method for Alert
     * @uses Alert::setRegId()
     * @uses Alert::setMId()
     * @uses Alert::setMDescription()
     * @uses Alert::setAType()
     * @uses Alert::setADescription()
     * @uses Alert::setAAlert_GMT()
     * @uses Alert::setADeleted()
     * @uses Alert::setADeleted_GMT()
     * @uses Alert::setAUserDeleted()
     * @uses Alert::setAComments()
     * @param int $regId
     * @param string $mId
     * @param string $mDescription
     * @param string $aType
     * @param string $aDescription
     * @param string $aAlert_GMT
     * @param string $aDeleted
     * @param string $aDeleted_GMT
     * @param string $aUserDeleted
     * @param string $aComments
     */
    public function __construct($regId = null, $mId = null, $mDescription = null, $aType = null, $aDescription = null, $aAlert_GMT = null, $aDeleted = null, $aDeleted_GMT = null, $aUserDeleted = null, $aComments = null)
    {
        $this
            ->setRegId($regId)
            ->setMId($mId)
            ->setMDescription($mDescription)
            ->setAType($aType)
            ->setADescription($aDescription)
            ->setAAlert_GMT($aAlert_GMT)
            ->setADeleted($aDeleted)
            ->setADeleted_GMT($aDeleted_GMT)
            ->setAUserDeleted($aUserDeleted)
            ->setAComments($aComments);
    }
    /**
     * Get regId value
     * @return int
     */
    public function getRegId()
    {
        return $this->regId;
    }
    /**
     * Set regId value
     * @param int $regId
     * @return \StructType\Alert
     */
    public function setRegId($regId = null)
    {
        // validation for constraint: int
        if (!is_null($regId) && !is_numeric($regId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($regId)), __LINE__);
        }
        $this->regId = $regId;
        return $this;
    }
    /**
     * Get mId value
     * @return string|null
     */
    public function getMId()
    {
        return $this->mId;
    }
    /**
     * Set mId value
     * @param string $mId
     * @return \StructType\Alert
     */
    public function setMId($mId = null)
    {
        // validation for constraint: string
        if (!is_null($mId) && !is_string($mId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mId)), __LINE__);
        }
        $this->mId = $mId;
        return $this;
    }
    /**
     * Get mDescription value
     * @return string|null
     */
    public function getMDescription()
    {
        return $this->mDescription;
    }
    /**
     * Set mDescription value
     * @param string $mDescription
     * @return \StructType\Alert
     */
    public function setMDescription($mDescription = null)
    {
        // validation for constraint: string
        if (!is_null($mDescription) && !is_string($mDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mDescription)), __LINE__);
        }
        $this->mDescription = $mDescription;
        return $this;
    }
    /**
     * Get aType value
     * @return string|null
     */
    public function getAType()
    {
        return $this->aType;
    }
    /**
     * Set aType value
     * @param string $aType
     * @return \StructType\Alert
     */
    public function setAType($aType = null)
    {
        // validation for constraint: string
        if (!is_null($aType) && !is_string($aType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($aType)), __LINE__);
        }
        $this->aType = $aType;
        return $this;
    }
    /**
     * Get aDescription value
     * @return string|null
     */
    public function getADescription()
    {
        return $this->aDescription;
    }
    /**
     * Set aDescription value
     * @param string $aDescription
     * @return \StructType\Alert
     */
    public function setADescription($aDescription = null)
    {
        // validation for constraint: string
        if (!is_null($aDescription) && !is_string($aDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($aDescription)), __LINE__);
        }
        $this->aDescription = $aDescription;
        return $this;
    }
    /**
     * Get aAlert_GMT value
     * @return string|null
     */
    public function getAAlert_GMT()
    {
        return $this->aAlert_GMT;
    }
    /**
     * Set aAlert_GMT value
     * @param string $aAlert_GMT
     * @return \StructType\Alert
     */
    public function setAAlert_GMT($aAlert_GMT = null)
    {
        // validation for constraint: string
        if (!is_null($aAlert_GMT) && !is_string($aAlert_GMT)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($aAlert_GMT)), __LINE__);
        }
        $this->aAlert_GMT = $aAlert_GMT;
        return $this;
    }
    /**
     * Get aDeleted value
     * @return string|null
     */
    public function getADeleted()
    {
        return $this->aDeleted;
    }
    /**
     * Set aDeleted value
     * @param string $aDeleted
     * @return \StructType\Alert
     */
    public function setADeleted($aDeleted = null)
    {
        // validation for constraint: string
        if (!is_null($aDeleted) && !is_string($aDeleted)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($aDeleted)), __LINE__);
        }
        $this->aDeleted = $aDeleted;
        return $this;
    }
    /**
     * Get aDeleted_GMT value
     * @return string|null
     */
    public function getADeleted_GMT()
    {
        return $this->aDeleted_GMT;
    }
    /**
     * Set aDeleted_GMT value
     * @param string $aDeleted_GMT
     * @return \StructType\Alert
     */
    public function setADeleted_GMT($aDeleted_GMT = null)
    {
        // validation for constraint: string
        if (!is_null($aDeleted_GMT) && !is_string($aDeleted_GMT)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($aDeleted_GMT)), __LINE__);
        }
        $this->aDeleted_GMT = $aDeleted_GMT;
        return $this;
    }
    /**
     * Get aUserDeleted value
     * @return string|null
     */
    public function getAUserDeleted()
    {
        return $this->aUserDeleted;
    }
    /**
     * Set aUserDeleted value
     * @param string $aUserDeleted
     * @return \StructType\Alert
     */
    public function setAUserDeleted($aUserDeleted = null)
    {
        // validation for constraint: string
        if (!is_null($aUserDeleted) && !is_string($aUserDeleted)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($aUserDeleted)), __LINE__);
        }
        $this->aUserDeleted = $aUserDeleted;
        return $this;
    }
    /**
     * Get aComments value
     * @return string|null
     */
    public function getAComments()
    {
        return $this->aComments;
    }
    /**
     * Set aComments value
     * @param string $aComments
     * @return \StructType\Alert
     */
    public function setAComments($aComments = null)
    {
        // validation for constraint: string
        if (!is_null($aComments) && !is_string($aComments)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($aComments)), __LINE__);
        }
        $this->aComments = $aComments;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Alert
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
