<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DriversLog StructType
 * @subpackage Structs
 */
class DriversLog extends AbstractStructBase
{
    /**
     * The regId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $regId;
    /**
     * The dr_Id
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $dr_Id;
    /**
     * The mId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $mId;
    /**
     * The drl_name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $drl_name;
    /**
     * The drl_assign
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $drl_assign;
    /**
     * The drl_user
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $drl_user;
    /**
     * The drl_UTCdatetime
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $drl_UTCdatetime;
    /**
     * Constructor method for DriversLog
     * @uses DriversLog::setRegId()
     * @uses DriversLog::setDr_Id()
     * @uses DriversLog::setMId()
     * @uses DriversLog::setDrl_name()
     * @uses DriversLog::setDrl_assign()
     * @uses DriversLog::setDrl_user()
     * @uses DriversLog::setDrl_UTCdatetime()
     * @param int $regId
     * @param int $dr_Id
     * @param string $mId
     * @param string $drl_name
     * @param string $drl_assign
     * @param string $drl_user
     * @param string $drl_UTCdatetime
     */
    public function __construct($regId = null, $dr_Id = null, $mId = null, $drl_name = null, $drl_assign = null, $drl_user = null, $drl_UTCdatetime = null)
    {
        $this
            ->setRegId($regId)
            ->setDr_Id($dr_Id)
            ->setMId($mId)
            ->setDrl_name($drl_name)
            ->setDrl_assign($drl_assign)
            ->setDrl_user($drl_user)
            ->setDrl_UTCdatetime($drl_UTCdatetime);
    }
    /**
     * Get regId value
     * @return int
     */
    public function getRegId()
    {
        return $this->regId;
    }
    /**
     * Set regId value
     * @param int $regId
     * @return \StructType\DriversLog
     */
    public function setRegId($regId = null)
    {
        // validation for constraint: int
        if (!is_null($regId) && !is_numeric($regId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($regId)), __LINE__);
        }
        $this->regId = $regId;
        return $this;
    }
    /**
     * Get dr_Id value
     * @return int
     */
    public function getDr_Id()
    {
        return $this->dr_Id;
    }
    /**
     * Set dr_Id value
     * @param int $dr_Id
     * @return \StructType\DriversLog
     */
    public function setDr_Id($dr_Id = null)
    {
        // validation for constraint: int
        if (!is_null($dr_Id) && !is_numeric($dr_Id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($dr_Id)), __LINE__);
        }
        $this->dr_Id = $dr_Id;
        return $this;
    }
    /**
     * Get mId value
     * @return string|null
     */
    public function getMId()
    {
        return $this->mId;
    }
    /**
     * Set mId value
     * @param string $mId
     * @return \StructType\DriversLog
     */
    public function setMId($mId = null)
    {
        // validation for constraint: string
        if (!is_null($mId) && !is_string($mId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mId)), __LINE__);
        }
        $this->mId = $mId;
        return $this;
    }
    /**
     * Get drl_name value
     * @return string|null
     */
    public function getDrl_name()
    {
        return $this->drl_name;
    }
    /**
     * Set drl_name value
     * @param string $drl_name
     * @return \StructType\DriversLog
     */
    public function setDrl_name($drl_name = null)
    {
        // validation for constraint: string
        if (!is_null($drl_name) && !is_string($drl_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($drl_name)), __LINE__);
        }
        $this->drl_name = $drl_name;
        return $this;
    }
    /**
     * Get drl_assign value
     * @return string|null
     */
    public function getDrl_assign()
    {
        return $this->drl_assign;
    }
    /**
     * Set drl_assign value
     * @param string $drl_assign
     * @return \StructType\DriversLog
     */
    public function setDrl_assign($drl_assign = null)
    {
        // validation for constraint: string
        if (!is_null($drl_assign) && !is_string($drl_assign)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($drl_assign)), __LINE__);
        }
        $this->drl_assign = $drl_assign;
        return $this;
    }
    /**
     * Get drl_user value
     * @return string|null
     */
    public function getDrl_user()
    {
        return $this->drl_user;
    }
    /**
     * Set drl_user value
     * @param string $drl_user
     * @return \StructType\DriversLog
     */
    public function setDrl_user($drl_user = null)
    {
        // validation for constraint: string
        if (!is_null($drl_user) && !is_string($drl_user)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($drl_user)), __LINE__);
        }
        $this->drl_user = $drl_user;
        return $this;
    }
    /**
     * Get drl_UTCdatetime value
     * @return string|null
     */
    public function getDrl_UTCdatetime()
    {
        return $this->drl_UTCdatetime;
    }
    /**
     * Set drl_UTCdatetime value
     * @param string $drl_UTCdatetime
     * @return \StructType\DriversLog
     */
    public function setDrl_UTCdatetime($drl_UTCdatetime = null)
    {
        // validation for constraint: string
        if (!is_null($drl_UTCdatetime) && !is_string($drl_UTCdatetime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($drl_UTCdatetime)), __LINE__);
        }
        $this->drl_UTCdatetime = $drl_UTCdatetime;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DriversLog
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
