<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GET_PendingAlerts StructType
 * @subpackage Structs
 */
class GET_PendingAlerts extends AbstractStructBase
{
    /**
     * The User
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $User;
    /**
     * The Password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Password;
    /**
     * The FleetId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FleetId;
    /**
     * The alertTypes
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $alertTypes;
    /**
     * Constructor method for GET_PendingAlerts
     * @uses GET_PendingAlerts::setUser()
     * @uses GET_PendingAlerts::setPassword()
     * @uses GET_PendingAlerts::setFleetId()
     * @uses GET_PendingAlerts::setAlertTypes()
     * @param string $user
     * @param string $password
     * @param string $fleetId
     * @param string $alertTypes
     */
    public function __construct($user = null, $password = null, $fleetId = null, $alertTypes = null)
    {
        $this
            ->setUser($user)
            ->setPassword($password)
            ->setFleetId($fleetId)
            ->setAlertTypes($alertTypes);
    }
    /**
     * Get User value
     * @return string|null
     */
    public function getUser()
    {
        return $this->User;
    }
    /**
     * Set User value
     * @param string $user
     * @return \StructType\GET_PendingAlerts
     */
    public function setUser($user = null)
    {
        // validation for constraint: string
        if (!is_null($user) && !is_string($user)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($user)), __LINE__);
        }
        $this->User = $user;
        return $this;
    }
    /**
     * Get Password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->Password;
    }
    /**
     * Set Password value
     * @param string $password
     * @return \StructType\GET_PendingAlerts
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->Password = $password;
        return $this;
    }
    /**
     * Get FleetId value
     * @return string|null
     */
    public function getFleetId()
    {
        return $this->FleetId;
    }
    /**
     * Set FleetId value
     * @param string $fleetId
     * @return \StructType\GET_PendingAlerts
     */
    public function setFleetId($fleetId = null)
    {
        // validation for constraint: string
        if (!is_null($fleetId) && !is_string($fleetId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fleetId)), __LINE__);
        }
        $this->FleetId = $fleetId;
        return $this;
    }
    /**
     * Get alertTypes value
     * @return string|null
     */
    public function getAlertTypes()
    {
        return $this->alertTypes;
    }
    /**
     * Set alertTypes value
     * @param string $alertTypes
     * @return \StructType\GET_PendingAlerts
     */
    public function setAlertTypes($alertTypes = null)
    {
        // validation for constraint: string
        if (!is_null($alertTypes) && !is_string($alertTypes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($alertTypes)), __LINE__);
        }
        $this->alertTypes = $alertTypes;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GET_PendingAlerts
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
