<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GET_ReferencePoints StructType
 * @subpackage Structs
 */
class GET_ReferencePoints extends AbstractStructBase
{
    /**
     * The User
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $User;
    /**
     * The Password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Password;
    /**
     * The fleetId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $fleetId;
    /**
     * The pointId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $pointId;
    /**
     * Constructor method for GET_ReferencePoints
     * @uses GET_ReferencePoints::setUser()
     * @uses GET_ReferencePoints::setPassword()
     * @uses GET_ReferencePoints::setFleetId()
     * @uses GET_ReferencePoints::setPointId()
     * @param string $user
     * @param string $password
     * @param string $fleetId
     * @param string $pointId
     */
    public function __construct($user = null, $password = null, $fleetId = null, $pointId = null)
    {
        $this
            ->setUser($user)
            ->setPassword($password)
            ->setFleetId($fleetId)
            ->setPointId($pointId);
    }
    /**
     * Get User value
     * @return string|null
     */
    public function getUser()
    {
        return $this->User;
    }
    /**
     * Set User value
     * @param string $user
     * @return \StructType\GET_ReferencePoints
     */
    public function setUser($user = null)
    {
        // validation for constraint: string
        if (!is_null($user) && !is_string($user)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($user)), __LINE__);
        }
        $this->User = $user;
        return $this;
    }
    /**
     * Get Password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->Password;
    }
    /**
     * Set Password value
     * @param string $password
     * @return \StructType\GET_ReferencePoints
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->Password = $password;
        return $this;
    }
    /**
     * Get fleetId value
     * @return string|null
     */
    public function getFleetId()
    {
        return $this->fleetId;
    }
    /**
     * Set fleetId value
     * @param string $fleetId
     * @return \StructType\GET_ReferencePoints
     */
    public function setFleetId($fleetId = null)
    {
        // validation for constraint: string
        if (!is_null($fleetId) && !is_string($fleetId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fleetId)), __LINE__);
        }
        $this->fleetId = $fleetId;
        return $this;
    }
    /**
     * Get pointId value
     * @return string|null
     */
    public function getPointId()
    {
        return $this->pointId;
    }
    /**
     * Set pointId value
     * @param string $pointId
     * @return \StructType\GET_ReferencePoints
     */
    public function setPointId($pointId = null)
    {
        // validation for constraint: string
        if (!is_null($pointId) && !is_string($pointId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pointId)), __LINE__);
        }
        $this->pointId = $pointId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GET_ReferencePoints
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
