<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GET_ZonesList StructType
 * @subpackage Structs
 */
class GET_ZonesList extends AbstractStructBase
{
    /**
     * The User
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $User;
    /**
     * The Password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Password;
    /**
     * The FleetId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FleetId;
    /**
     * The getPoints
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $getPoints;
    /**
     * Constructor method for GET_ZonesList
     * @uses GET_ZonesList::setUser()
     * @uses GET_ZonesList::setPassword()
     * @uses GET_ZonesList::setFleetId()
     * @uses GET_ZonesList::setGetPoints()
     * @param string $user
     * @param string $password
     * @param string $fleetId
     * @param string $getPoints
     */
    public function __construct($user = null, $password = null, $fleetId = null, $getPoints = null)
    {
        $this
            ->setUser($user)
            ->setPassword($password)
            ->setFleetId($fleetId)
            ->setGetPoints($getPoints);
    }
    /**
     * Get User value
     * @return string|null
     */
    public function getUser()
    {
        return $this->User;
    }
    /**
     * Set User value
     * @param string $user
     * @return \StructType\GET_ZonesList
     */
    public function setUser($user = null)
    {
        // validation for constraint: string
        if (!is_null($user) && !is_string($user)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($user)), __LINE__);
        }
        $this->User = $user;
        return $this;
    }
    /**
     * Get Password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->Password;
    }
    /**
     * Set Password value
     * @param string $password
     * @return \StructType\GET_ZonesList
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->Password = $password;
        return $this;
    }
    /**
     * Get FleetId value
     * @return string|null
     */
    public function getFleetId()
    {
        return $this->FleetId;
    }
    /**
     * Set FleetId value
     * @param string $fleetId
     * @return \StructType\GET_ZonesList
     */
    public function setFleetId($fleetId = null)
    {
        // validation for constraint: string
        if (!is_null($fleetId) && !is_string($fleetId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fleetId)), __LINE__);
        }
        $this->FleetId = $fleetId;
        return $this;
    }
    /**
     * Get getPoints value
     * @return string|null
     */
    public function getGetPoints()
    {
        return $this->getPoints;
    }
    /**
     * Set getPoints value
     * @param string $getPoints
     * @return \StructType\GET_ZonesList
     */
    public function setGetPoints($getPoints = null)
    {
        // validation for constraint: string
        if (!is_null($getPoints) && !is_string($getPoints)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($getPoints)), __LINE__);
        }
        $this->getPoints = $getPoints;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GET_ZonesList
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
