<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GeoFenceLog StructType
 * @subpackage Structs
 */
class GeoFenceLog extends AbstractStructBase
{
    /**
     * The eventLocation
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\EventLocation
     */
    public $eventLocation;
    /**
     * The listReferencePoint
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfReferencePointStruct
     */
    public $listReferencePoint;
    /**
     * Constructor method for GeoFenceLog
     * @uses GeoFenceLog::setEventLocation()
     * @uses GeoFenceLog::setListReferencePoint()
     * @param \StructType\EventLocation $eventLocation
     * @param \ArrayType\ArrayOfReferencePointStruct $listReferencePoint
     */
    public function __construct(\StructType\EventLocation $eventLocation = null, \ArrayType\ArrayOfReferencePointStruct $listReferencePoint = null)
    {
        $this
            ->setEventLocation($eventLocation)
            ->setListReferencePoint($listReferencePoint);
    }
    /**
     * Get eventLocation value
     * @return \StructType\EventLocation
     */
    public function getEventLocation()
    {
        return $this->eventLocation;
    }
    /**
     * Set eventLocation value
     * @param \StructType\EventLocation $eventLocation
     * @return \StructType\GeoFenceLog
     */
    public function setEventLocation(\StructType\EventLocation $eventLocation = null)
    {
        $this->eventLocation = $eventLocation;
        return $this;
    }
    /**
     * Get listReferencePoint value
     * @return \ArrayType\ArrayOfReferencePointStruct|null
     */
    public function getListReferencePoint()
    {
        return $this->listReferencePoint;
    }
    /**
     * Set listReferencePoint value
     * @param \ArrayType\ArrayOfReferencePointStruct $listReferencePoint
     * @return \StructType\GeoFenceLog
     */
    public function setListReferencePoint(\ArrayType\ArrayOfReferencePointStruct $listReferencePoint = null)
    {
        $this->listReferencePoint = $listReferencePoint;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GeoFenceLog
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
