<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GroupGeoFencePoints StructType
 * @subpackage Structs
 */
class GroupGeoFencePoints extends AbstractStructBase
{
    /**
     * The groupGeoFence
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\GroupGeofence
     */
    public $groupGeoFence;
    /**
     * The listReferencePoint
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfReferencePointStruct
     */
    public $listReferencePoint;
    /**
     * Constructor method for GroupGeoFencePoints
     * @uses GroupGeoFencePoints::setGroupGeoFence()
     * @uses GroupGeoFencePoints::setListReferencePoint()
     * @param \StructType\GroupGeofence $groupGeoFence
     * @param \ArrayType\ArrayOfReferencePointStruct $listReferencePoint
     */
    public function __construct(\StructType\GroupGeofence $groupGeoFence = null, \ArrayType\ArrayOfReferencePointStruct $listReferencePoint = null)
    {
        $this
            ->setGroupGeoFence($groupGeoFence)
            ->setListReferencePoint($listReferencePoint);
    }
    /**
     * Get groupGeoFence value
     * @return \StructType\GroupGeofence
     */
    public function getGroupGeoFence()
    {
        return $this->groupGeoFence;
    }
    /**
     * Set groupGeoFence value
     * @param \StructType\GroupGeofence $groupGeoFence
     * @return \StructType\GroupGeoFencePoints
     */
    public function setGroupGeoFence(\StructType\GroupGeofence $groupGeoFence = null)
    {
        $this->groupGeoFence = $groupGeoFence;
        return $this;
    }
    /**
     * Get listReferencePoint value
     * @return \ArrayType\ArrayOfReferencePointStruct|null
     */
    public function getListReferencePoint()
    {
        return $this->listReferencePoint;
    }
    /**
     * Set listReferencePoint value
     * @param \ArrayType\ArrayOfReferencePointStruct $listReferencePoint
     * @return \StructType\GroupGeoFencePoints
     */
    public function setListReferencePoint(\ArrayType\ArrayOfReferencePointStruct $listReferencePoint = null)
    {
        $this->listReferencePoint = $listReferencePoint;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GroupGeoFencePoints
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
